package com.eliasbalasis.tibcopagebus4gwt.client;

import java.util.EventListener;
/**
 * Implement this interface to implement custom logic for handling published messages.
 *
 */
public interface PageBusListener extends EventListener {
	/**
	 * This method is called whenever a message is published.
	 * Is is implied that a related subscription has occurred earlier
	 * using {@linkplain PageBusAdapter#PageBusSubscribe}</br>
	 * @param event
	 * The event representation supporting methods for extracting the message data
	 */
	public void onPageBusSubscriptionCallback(PageBusEvent event);

	/**
	 * An custom name for this listener used to distinguish it from other active listeners of the same type
	 * @return
	 * The name of this listener
	 */
	public String getName();
}
