package com.eliasbalasis.tibcopagebus4gwt.testsubscriber.client;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import org.juglar.gwt.jsonizer.client.Jsonizer;

import com.eliasbalasis.tibcopagebus4gwt.client.PageBusAdapter;
import com.eliasbalasis.tibcopagebus4gwt.client.PageBusAdapterException;
import com.eliasbalasis.tibcopagebus4gwt.client.PageBusEvent;
import com.eliasbalasis.tibcopagebus4gwt.client.PageBusListener;
import com.eliasbalasis.tibcopagebus4gwt.testsubscriber.client.PageBusSubscriber;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public final class PageBusSubscriber extends Composite {
	private final String messageSubject = "com.eliasbalasis.tibcopagebus4gwt.testsubscriber.client.PageBusSubscriber.test";
	private final PageBusAdapter pageBusAdapter;
	public PageBusSubscriber() {
		final VerticalPanel mainPanel = new VerticalPanel();
		initWidget(mainPanel);
		setSize("100%", "100%");
		mainPanel.setSize("100%", "100%");

		final HorizontalPanel pageBusAdapterPanel = new HorizontalPanel();
		mainPanel.add(pageBusAdapterPanel);
		mainPanel.setCellVerticalAlignment(pageBusAdapterPanel, HasVerticalAlignment.ALIGN_MIDDLE);
		mainPanel.setCellHorizontalAlignment(pageBusAdapterPanel, HasHorizontalAlignment.ALIGN_CENTER);
		mainPanel.setCellHeight(pageBusAdapterPanel, "100%");
		mainPanel.setCellWidth(pageBusAdapterPanel, "100%");
		pageBusAdapterPanel.setSize("100%", "100%");
		pageBusAdapterPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);

		pageBusAdapter = new PageBusAdapter();
		pageBusAdapterPanel.add(pageBusAdapter);
		pageBusAdapterPanel.setCellVerticalAlignment(pageBusAdapter, HasVerticalAlignment.ALIGN_MIDDLE);
		pageBusAdapterPanel.setCellHorizontalAlignment(pageBusAdapter, HasHorizontalAlignment.ALIGN_CENTER);
		pageBusAdapterPanel.setCellWidth(pageBusAdapter, "100%");
		pageBusAdapter.setSize("100%", "100%");
		pageBusAdapterPanel.setCellHeight(pageBusAdapter, "100%");

		final HorizontalPanel buttonsPanel = new HorizontalPanel();
		mainPanel.add(buttonsPanel);
		buttonsPanel.setSize("100%", "30");
		buttonsPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		buttonsPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);

		final HorizontalPanel buttonsGroup = new HorizontalPanel();
		buttonsPanel.add(buttonsGroup);
		buttonsGroup.setSize("100%", "100%");
		buttonsGroup.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		buttonsGroup.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);

		final Button subscribeButton = new Button();
		buttonsGroup.add(subscribeButton);
		subscribeButton.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				doSubscribe();
			}
		});
		subscribeButton.setText("Subscribe");

		final Button publishButton = new Button();
		buttonsGroup.add(publishButton);
		publishButton.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				doPublish();
			}
		});
		publishButton.setText("Publish");

		final Button unsubscribeButton = new Button();
		buttonsGroup.add(unsubscribeButton);
		unsubscribeButton.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				doUnsubscribe();
			}
		});
		unsubscribeButton.setText("Unsubscribe");

		final Button clearLogButton = new Button();
		buttonsGroup.add(clearLogButton);
		clearLogButton.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				doClearLog();
			}
		});
		clearLogButton.setText("Clear Log");

		final CheckBox loggingCheckBox = new CheckBox();
		buttonsGroup.add(loggingCheckBox);
		loggingCheckBox.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				pageBusAdapter.EnableLogging(loggingCheckBox.isChecked());
			}
		});
		loggingCheckBox.setText("Logging");
		pageBusAdapter.EnableLogging(true);
		loggingCheckBox.setChecked(pageBusAdapter.isLoggingEnabled());

		final CheckBox moveCursorCheckBox = new CheckBox();
		buttonsGroup.add(moveCursorCheckBox);
		moveCursorCheckBox.addClickListener(new ClickListener() {
			public void onClick(final Widget sender) {
				pageBusAdapter.setMoveCursorOnEvent(moveCursorCheckBox.isChecked());
			}
		});
		moveCursorCheckBox.setText("Move Cursor");
		pageBusAdapter.setMoveCursorOnEvent(true);
		moveCursorCheckBox.setChecked(pageBusAdapter.isMoveCursorOnEvent());

		pageBusAdapter.addPageBusSubscriptionCallbackListener(
			new PageBusListener() {
				public String getName() {
					return "testListener";
				}
				public void onPageBusSubscriptionCallback(PageBusEvent event) {
					if (event.getSubject().equals(messageSubject)==false) {
						return;
					}
					PersonRepository personRepository = null;
					try {
						personRepository = (PersonRepository)event.getMessage((Jsonizer)GWT.create(PersonRepositoryJsonizer.class));
					} catch(PageBusAdapterException ex) {
						Window.alert("Failed to retrieve message data\n\n"+ex.toString()+"\n\n"+ex.getCause().toString());
					}
					SubscriberData subscriberData = null;
					try {
						subscriberData = (SubscriberData)event.getSubscriberData((Jsonizer)GWT.create(SubscriberDataJsonizer.class));;
					} catch(PageBusAdapterException ex) {
						Window.alert("Failed to retrieve subscription data\n\n"+ex.toString()+"\n\n"+ex.getCause().toString());
					}
					String summary = null;
					summary =
						"Received event "+"'"+event.getSubject()+"'"+"\n\n"+
						"Message Data"+
						"\n\n"+
						personRepository.toString()+
						"\n\n"+
						"Subscriber Data"+
						"\n\n"+
						subscriberData.toString();
					Window.alert(summary);
				}
			}
		);
	}

	private void doSubscribe() {
		try {
			pageBusAdapter.PageBusSubscribe(messageSubject, null, null, createSubscriberData(), (Jsonizer)GWT.create(SubscriberDataJsonizer.class));
		} catch(PageBusAdapterException ex) {
			Window.alert("Subscription to "+messageSubject+" failed\n\n"+ex.toString()+"\n\n"+ex.getCause().toString());
		}
	}
	private void doPublish() {
		try {
			pageBusAdapter.PageBusPublish(messageSubject, createMessageData(), (Jsonizer)GWT.create(PersonRepositoryJsonizer.class));
		} catch(PageBusAdapterException ex) {
			Window.alert("Publication of "+messageSubject+" failed\n\n"+ex.toString()+"\n\n"+ex.getCause().toString());
		}
	}
	private void doUnsubscribe() {
		try {
			pageBusAdapter.PageBusUnsubscribe(messageSubject);
		} catch(PageBusAdapterException ex) {
			Window.alert("Failed to ubsubscribe from "+messageSubject+"\n\n"+ex.toString()+"\n\n"+ex.getCause().toString());
		}
	}
	private void doClearLog() {
		pageBusAdapter.ClearBuffer();
	}
	private SubscriberData createSubscriberData() {
		SubscriberData subscriberData  = new SubscriberData();
		subscriberData.setHeader("myHeader");
		subscriberData.setBody("myBody");
		return subscriberData ;
	}
	private PersonRepository createMessageData() {
		PersonRepository personRepository = new PersonRepository();
		personRepository.setName("testRepository");
		Collection persons = new ArrayList();
		//
		Person person1 = new Person();
		person1.setName("person1");
		person1.setDescription("This is person1");
		person1.setIntValue(101);
		person1.setDateValue(new Date());
		person1.setFloatValue(0.101f);
		person1.setDoubleValue(Double.POSITIVE_INFINITY);
		person1.setBooleanValue(true);
		//
		Person person2 = new Person();
		person2.setName("person2");
		person2.setDescription("This is person2");
		person2.setIntValue(102);
		person2.setDateValue(new Date());
		person2.setFloatValue(0.102f);
		person2.setDoubleValue(Double.NaN);
		person2.setBooleanValue(false);
		//
		Person person3 = new Person();
		person3.setName("person3");
		person3.setDescription("This is person3");
		person3.setIntValue(103);
		person3.setDateValue(new Date());
		person3.setFloatValue(0.103f);
		person3.setDoubleValue(1.7976e308d);
		person3.setBooleanValue(false);
		persons.add(person1);
		persons.add(person2);
		persons.add(person3);
		personRepository.setPersons(persons);
		return personRepository;
	}
}
